> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://nemo-platform.docs.buildwithfern.com/nemo/platform/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://nemo-platform.docs.buildwithfern.com/nemo/platform/_mcp/server.

# Add workspace member

POST https://host.com/apis/entities/v2/workspaces/{workspace}/members
Content-Type: application/json

Add a new member to the workspace with specified roles.

This creates role bindings for the specified principal with the given roles.
By default, this endpoint waits for the roles to propagate before returning.
Use `wait_role_propagation=false` to skip waiting (useful for bulk operations).

Example:
```
POST /apis/entities/v2/workspaces/ml-team/members
{
    "principal": "user@example.com",
    "roles": ["Editor"]
}
```

Reference: https://nemo-platform.docs.buildwithfern.com/nemo/platform/nemo/platform/documentation/reference/api-reference/entity-store/add-workspace-member-apis-entities-v-2-workspaces-workspace-members-post

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Nemo Platform API
  version: 1.0.0
paths:
  /apis/entities/v2/workspaces/{workspace}/members:
    post:
      operationId: add-workspace-member-apis-entities-v-2-workspaces-workspace-members-post
      summary: Add workspace member
      description: >-
        Add a new member to the workspace with specified roles.


        This creates role bindings for the specified principal with the given
        roles.

        By default, this endpoint waits for the roles to propagate before
        returning.

        Use `wait_role_propagation=false` to skip waiting (useful for bulk
        operations).


        Example:

        ```

        POST /apis/entities/v2/workspaces/ml-team/members

        {
            "principal": "user@example.com",
            "roles": ["Editor"]
        }

        ```
      tags:
        - subpackage_entityStore
      parameters:
        - name: workspace
          in: path
          required: true
          schema:
            type: string
        - name: wait_role_propagation
          in: query
          description: >-
            If true, wait for roles to propagate before returning (default:
            true). Set to false for bulk operations.
          required: false
          schema:
            type: boolean
            default: true
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WorkspaceMember'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/WorkspaceMemberInput'
servers:
  - url: https://host.com
    description: Default
components:
  schemas:
    WorkspaceMemberInput:
      type: object
      properties:
        principal:
          type: string
          description: The principal identifier (email, user ID, or group ID)
        roles:
          type: array
          items:
            type: string
          default:
            - Editor
          description: List of roles to grant to the principal
      required:
        - principal
      description: Schema for adding a new workspace member.
      title: WorkspaceMemberInput
    WorkspaceMember:
      type: object
      properties:
        principal:
          type: string
          description: The principal identifier
        roles:
          type: array
          items:
            type: string
          description: List of roles granted to the principal
        granted_at:
          type: string
          format: date-time
          description: Earliest date when a role was granted to this principal
        granted_by:
          type: string
          description: Who granted the earliest role
      required:
        - principal
        - roles
      description: Workspace member response model.
      title: WorkspaceMember
    ValidationErrorLocItems:
      oneOf:
        - type: string
        - type: integer
      title: ValidationErrorLocItems
    ValidationError:
      type: object
      properties:
        loc:
          type: array
          items:
            $ref: '#/components/schemas/ValidationErrorLocItems'
        msg:
          type: string
        type:
          type: string
        input:
          description: Any type
        ctx:
          type: object
          additionalProperties:
            description: Any type
      required:
        - loc
        - msg
        - type
      title: ValidationError
    HTTPValidationError:
      type: object
      properties:
        detail:
          type: array
          items:
            $ref: '#/components/schemas/ValidationError'
      title: HTTPValidationError

```

## Examples



**Request**

```json
{
  "principal": "alice.smith@techcorp.com"
}
```

**Response**

```json
{
  "principal": "alice.smith@techcorp.com",
  "roles": [
    "Editor"
  ],
  "granted_at": "2024-01-15T09:30:00Z",
  "granted_by": "admin@techcorp.com"
}
```

**SDK Code**

```python
import requests

url = "https://host.com/apis/entities/v2/workspaces/workspace/members"

payload = { "principal": "alice.smith@techcorp.com" }
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://host.com/apis/entities/v2/workspaces/workspace/members';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"principal":"alice.smith@techcorp.com"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://host.com/apis/entities/v2/workspaces/workspace/members"

	payload := strings.NewReader("{\n  \"principal\": \"alice.smith@techcorp.com\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://host.com/apis/entities/v2/workspaces/workspace/members")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"principal\": \"alice.smith@techcorp.com\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://host.com/apis/entities/v2/workspaces/workspace/members")
  .header("Content-Type", "application/json")
  .body("{\n  \"principal\": \"alice.smith@techcorp.com\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://host.com/apis/entities/v2/workspaces/workspace/members', [
  'body' => '{
  "principal": "alice.smith@techcorp.com"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://host.com/apis/entities/v2/workspaces/workspace/members");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"principal\": \"alice.smith@techcorp.com\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = ["principal": "alice.smith@techcorp.com"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://host.com/apis/entities/v2/workspaces/workspace/members")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```